Unit jbCFile;
{
 Zakladni operace pro manipulaci se soubory
 (c) 1991-98 J.BENES, All right reserved
 VI.1998 convert to component J.B.
}
{$IfDef Win32}
  {$H-}
{$EndIf}
Interface
uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, {Buttons, Menus,} MmSystem{, IniFiles},FileCtrl;

(*
  swCMove      {soubor je presunut/prejmenovan}
  swCCopy      {soubor je kopirovan}
  swCOver      {cil bude prepsan}
  swCAppend    {k cili bude pripojeno}
  swCVisible   {panel bude zobrazen}
  swCSilent    {tichy prubeh bez panelu}
  swCBackup    {backup bude vytvoren ale jen pri rewrite}
  swCThrow     {backup nebude proveden (odhozen)}
  swCLastDate  {datum bude nastaveno podle cile/zdroje}
  swCUpdate    {datum zustane aktualni}
  swCNone      {nebude vyvolana udalost pro dialog}
  swCDialogs   {bude vyvolan dialog pro prepis souboru}
  swCRequest   {bude volan jednoduchy Dlg pro potvrzeni}
  swCSilented  {prubeh kopirovani probehne tise}
*)
Const
  ccMsg1='Error on make new directory';
  ccMsg2='Empty file is deleted';
  ccMsg3='Enought disk space for access';
type
  TCopyOrMove=(swCCopy,swCMove);
  TOverOrAppend=(swCAppend,swCOver);
  TProgressOrSilent=(swCSilent,swCProgress);
  TRequestOrSilent=(swCSilented,swCRequest);
  TOverDialogs=(swCNone,swCDialogs);
  TBackupOrThrow=(swCThrow,swCBackup);
  TSetFileDate=(swCActual,swCSource,swCDest);
  TCopyFileOption=(swMove, swOver, swPanel,swBackup, swDateTime);
  TCopyFileOptions=Set of TCopyFileOption;
  TNotifyEventProgress=procedure(Progress:Byte) of object;
  TNotifyEventDialog=procedure(Const Msg:String) of object;
  TCopyFile = class(TComponent)
  private
    { Private declarations }
    FSource,FDestination: String;
    FMoveSwitch:TCopyOrMove;
    FOverSwitch:TOverOrAppend;
    FOverDialogs:TOverDialogs;
    FProgress:TProgressOrSilent;
    FRequest:TRequestOrSilent;
    FBackup:TBackupOrThrow;
    FDateFile:TSetFileDate;
    {FOptions:TCopyFileOptions;}
    FOnCopy: TNotifyEvent;
    FOnProgress: TNotifyEventProgress;
    FOnDialog: TNotifyEventDialog;
  protected
    { Protected declarations }
    {procedure SetOptions(NewValue: TCopyFileOptions);}
    procedure SetMove(Value:TCopyOrMove);
    procedure SetOver(Value:TOverOrAppend);
    procedure SetOverDialogs(Value:TOverDialogs);
    procedure SetProgress(Value:TProgressOrSilent);
    procedure SetRequest(Value:TRequestOrSilent);
    procedure SetBackup(Value:TBackupOrThrow);
    procedure SetDateFile(Value:TSetFileDate);
    procedure SetSource(NewSource: String);
    procedure SetDestination(NewDestination: String);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function CopyFile:Boolean;
    function Size(Const FName:String):LongInt;
    function WriteLine(Const FName:String;Line: String):Boolean;
    function ReadLine(LineNo:Word;Const FName:String):String;
    function EraseNullFile(Const FName:String;show:Boolean):Boolean;
    function RenameFile(Const FNameOld,FNameNew:String;Backup:Boolean):Boolean;
    function MakeBackup(Const FName:String):Boolean;
    function ExistPath(Const FPath:String):Boolean;
    function TestDisk(Const FPath:String):Boolean;
    function MakeDir(Const Dir:String;show:Boolean):Boolean;
    function ExistFile(Const FName:String):Boolean;
    function DefaultDirectory:String;
  published
    { Published declarations }
    {Property Options :TCopyFileOptions Read FOptions Write SetOptions;}
    property CopyOrMove:TCopyOrMove read FMoveSwitch write SetMove default swCCopy;
    property OverOrAppend:TOverOrAppend read FOverSwitch write SetOver default swCAppend;
    property OverDialogs:TOverDialogs read FOverDialogs write SetOverDialogs default swCNone;
    property ProgressOrSilent:TProgressOrSilent read FProgress write SetProgress default swCSilent;
    property RequestOrSilent:TRequestOrSilent read FRequest write SetRequest default swCSilented;
    property BackupOrThrow:TBackupOrThrow read FBackup write SetBackup default swCBackup;
    property DateOptions:TSetFileDate read FDateFile write SetDateFile default swCActual;

    property Source:String read FSource write SetSource;
    property Destination:String read FDestination write SetDestination;

    property OnCopy: TNotifyEvent read FOnCopy write FOnCopy;
    property OnProgress: TNotifyEventProgress read FOnProgress write FOnProgress;
    property OnDialog: TNotifyEventDialog read FOnDialog write FOnDialog;
  End;

  Procedure Register;

Implementation

Uses jbStr;

procedure TCopyFile.SetMove;
Begin
  If value <> FMoveSwitch Then Begin
      FMoveSwitch := value;
  End;
End;
procedure TCopyFile.SetOver;
Begin
  If value <> FOverSwitch Then Begin
      FOverSwitch := value;
  End;
End;
procedure TCopyFile.SetOverDialogs;
Begin
  If value <> FOverDialogs Then Begin
      FOverDialogs := value;
  End;
End;
procedure TCopyFile.SetProgress;
Begin
  If value <> FProgress Then Begin
      FProgress := value;
  End;
End;
procedure TCopyFile.SetRequest;
Begin
  If value <> FRequest Then Begin
      FRequest := value;
  End;
End;
procedure TCopyFile.SetBackup;
Begin
  If value <> FBackup Then Begin
      Fbackup := value;
  End;
End;
procedure TCopyFile.SetDateFile;
Begin
  If value <> FDateFile Then Begin
      FDateFile := value;
  End;
End;
(*procedure TCopyFile.SetOptions;
Begin
  If NewValue = FOptions Then Exit;
  FOptions := NewValue;
End;*)

procedure TCopyFile.SetSource(NewSource: String);
Begin
  FSource := NewSource;
End;

procedure TCopyFile.SetDestination(NewDestination: String);
Begin
  FDestination := NewDestination;
End;

function TCopyFile.CopyFile;
Const velbuf = 4096; {standardni velikost bufferu}
  Function GetFileDateTime(Const FName:String):TDateTime;
  Var
    Handle:Integer;
  Begin
    Result:=-1;(*BadDateTime*)
    Handle := FileOpen(FName,fmOpenRead);
    If Handle = 0 Then Begin
      Result := FileDateToDateTime(FileGetDate(Handle));
      FileClose(Handle);
    End;
  End;
  Procedure SetFileDateTime(Const FName:String; DT:TDateTime);
  Var
    Handle:Integer;
  Begin
    Handle := FileOpen(FName,fmOpenRead);
    If Handle = 0 Then Begin
      FileSetDate(Handle,DateTimeToFileDate(DT));
      FileClose(Handle);
    End;
  End;
VAR
  F, Q: FILE;
  NumRead, NumWritten:{$IfDef Ver80}Word{$Else}Integer{$EndIf};
  {U: WORD;}
  Buffer1: Pointer;
  N, L: LONGINT;
  I: BYTE;
  SX,S,X,OldPath: String;
  DT:TDateTime;
Begin
  CopyFile := False;
  {--------------------------}
  S := ExpandFileName(FSource); {relativni jmena zmenit na absolutni}
  X := ExpandFileName(FDestination);
  {--------------------------}
  If (FMoveSwitch=swCMove) And (S=X) Then RenameFile(FSource,FDestination,false);
  If Not ExistFile (FSource) Then Exit;

  If FDateFile=swCSource Then
    DT:=GetFileDateTime(FSource);{toto je cas zdroje}
  {test na to zda se vejde zdroj do cile}
  If FOverSwitch<>swCOver Then {jen kdyz neprepisujes}
    If Size(FSource)>DiskFree(Ord(UpCase(X[1]))-Ord('A')+1) Then Begin
      If FRequest=swCRequest Then Begin
        If Assigned(FOnDialog) Then
          FOnDialog(ccMsg3)
        Else
          MessageDlg(ccMsg3,mtWarning,[mbOK],0);
      End;
      Exit;
    End;
  System.AsSign (F, FSource);
  Try
    ReSet (F, 1);
    {pocet buferu}
    L := FileSize(F) Div velbuf;
    If (FileSize(F) Mod velbuf) <> 0 Then Inc (L);
    If L = 0 Then L := 1;
    {------------}
    If ExistFile (FDestination) Then Begin

      If FDateFile=swCDest Then
        DT:=GetFileDateTime(FDestination);{toto je cas cile, pokud existuje}

      System.AsSign(Q, FDestination);

      If FOverSwitch=swCOver Then Begin
        If FBackup=swCBackup Then MakeBackup(FDestination); {uschov puvodni, je-li zadano}
        SysUtils.DeleteFile(FDestination);
        If Size(FSource)>DiskFree(Ord(UpCase(X[1]))-Ord('A')+1) Then Begin
          If FRequest=swCRequest Then Begin
            If Assigned(FOnDialog) Then
              FOnDialog(ccMsg3)
            Else
              MessageDlg(ccMsg3,mtWarning,[mbOK],0);
          End;
          Exit;{nevejde se, ukonci to}
        End;
        REWRITE (Q, 1);{prepis/zaloz novy na swCOver}
      End
      ELSE Begin {append, pridej}
        RESET (Q, 1);
        SEEK (Q, FILESIZE (Q) );{bude do neho zapisovano}
      End;
    End
    Else Begin
      System.ASSIGN (Q, FDestination);
      {$I-}
      REWRITE (Q, 1); {soubor neexistuje a tak bude zalozen}
      {$I+}
      If IORESULT <> 0 Then Begin {doslo k chybe? asi neexistuje adresar}
        GetDir(0,OldPath); {odkud}
        If OldPath[1] = FDestination[1] Then ChDir('\'){ke koreni}
        ELSE Begin
          ChDir(Copy(FDestination,1,2));{zmena disku}
          ChDir('\'){ke koreni}
        End;
        I := 0;
        If FDestination[2]=':' Then I := 3;
        If FDestination[3]='\' Then I := 4;
        If I <> 0 Then SX := Copy(ExtractFilePath(FDestination),I,255)
        Else SX := ExtractFilePath(FDestination);
        If SX[Length(SX)] = '\' Then Dec(Byte(SX[0]));
        If NOT MakeDir(SX,FRequest=swCRequest) Then Begin
          If FRequest=swCRequest Then Begin
            {pipni a zahlas msgdlg}
            If Assigned(FOnDialog) Then
              FOnDialog(ccMsg1)
            Else
              MessageDlg(ccMsg1,mtWarning,[mbOK],0);
          End;
          Exit; {doslo k chybe a pak ven}
        End;
        ChDir(OldPath); {navrat do puvodniho adresare}
        REWRITE (Q, 1); {opakuj znovuotevreni souboru}
      End;
    End;
    If FProgress=swCProgress Then Begin
      If Assigned(FOnProgress) Then
        FOnProgress(0);
    End;
    N := 0;
    {---vyroba bufferu pro testy---}
    GetMem(Buffer1,velbuf);
    {---vlastni kopie/move...}
    REPEAT
      {U := 0;{citac useku na buferu}
      If Assigned(FOnCopy) Then
        FOnCopy(Self);
      BLOCKREAD (F, BUFFER1^, velbuf, NumRead); {nacte usek do buferu}
      BLOCKWRITE (Q, BUFFER1^, NumRead, NumWritten); {pak na jednom buferu}
      INC (N);
      If FProgress=swCProgress Then Begin
        If Assigned(FOnProgress) Then
          FOnProgress(ROUND(N/(L/100)) );
      End;
    UNTIL (NumRead = 0) OR (NumWritten <> NumRead);
    FreeMem(Buffer1,velbuf);
   {oba regulerne uzavri}
    CLOSE (Q);
  Finally
    CLOSE (F);
  End;
  {------------------------------}
  If FProgress=swCProgress Then Begin
    If Assigned(FOnProgress) Then
      FOnProgress(100);
  End;
  If FDateFile in [swCSource,swCDest] Then
   {cas nastav, jen je-li to pozadovano}
    SetFileDateTime(FDestination,DT);
  If FMoveSwitch=swCMove Then SysUtils.DeleteFile(FSource);

  CopyFile := True; {dosels az sem, pak je vse O.K.}
End;
function TCopyFile.Size(Const FName:String):LongInt;
var
  F: File Of Byte;
Begin
  SIZE := 0;
  If Not ExistFile (FName) Then Exit;
  AsSignFile (F, FName);
  ReSet (F);
  SIZE := FileSize (F);
  Close (F);
End;
function TCopyFile.WriteLine(Const FName:String;Line: String):Boolean;
Var F:Text;
Begin
  Result:=True;
  AsSignFile(F,FName);
  {$I-}
  Append(F);
  {$I+}
  If IoResult <> 0 Then ReWrite(F);
  WriteLn(F,Line);
  Close(F);
End;
function TCopyFile.ReadLine(LineNo:Word;Const FName:String):String;
Var F:Text;
    S:String;
    N:Word;
    A:Array[1..4096] of Char;
Begin
  ReadLine := '';
  AsSignFile(F,FName);
  SetTextBuf(F,A);
  {$I-}
  ReSet(F);
  {$I+}
  If IoResult <> 0 Then Exit;
  N:=0;
  While Not Eof(F) Do Begin
    ReadLn(F,S);Inc(N);
    If N=LineNo Then Begin
      ReadLine:=S;
      Close(F);
      Exit;
    End;
  End;
  Close(F);
End;
function TCopyFile.EraseNullFile;
var
  P: File of Byte;
Begin
  Result:=True;
  If Size (FName) = 0 Then Begin
    SysUtils.DeleteFile (FName);
    If show Then Begin {neni tichy prubeh}
      WRITE (#7);
      MessageDlg(ccMsg2,mtWarning,[mbOK],0);
    End;
  End;
End;
function TCopyFile.RenameFile(Const FNameOld,FNameNew:String;Backup:Boolean):Boolean;
Var F:File;
Begin
  Result:=False;
  If Not ExistFile(FNameOld) Then Exit;
  If backup Then MakeBackup(FNameNew) Else SysUtils.DeleteFile(FNameNew);
  AsSignFile(F,FNameOld);
  {$I-}
  Rename(F,FNameNew);
  {$I+}
  Result:=IoResult=0;
End;
function TCopyFile.MakeBackup(Const FName:String):Boolean;
Begin
  Result:=False;
  If Not ExistFile (FName) Then Exit;
  Result:=RenameFile(FName,ChangeFileExt(FName,'.BAK'),true);
End;
function TCopyFile.ExistPath(Const FPath:String):Boolean;
Var
  I:Integer;
  O,P:String;
Begin
  Result:=False;
  GetDir(0,O);
  P:=FPath;
  If P[Length(P)] = '\' Then Dec(Byte(P[0])); {kvuli chdir, nesnasi to}
  {$I-}
  ChDir(P);
  {$I+}
  I := IoResult;
  ChDir(O);
  Result := Not(I in [3,152]);
End;
function TCopyFile.TestDisk(Const FPath:String):Boolean;
Var F:File;
    I:Integer;
Begin
  AsSignFile(F,AddLastChar('\',FPath)+'$.');
  {$I-}
  ReWrite(F,1);
  {$I+}
  I := IoResult;
  If I = 0 Then Begin
    Close(F);
    Erase(F);
  End;
  TestDisk:=I=0;
End;
function TCopyFile.MakeDir(Const Dir:String;show:Boolean):Boolean;
Begin
  MakeDir := True;
  ForceDirectories(Dir);
End;
function TCopyFile.ExistFile(Const FName:String):Boolean;
Var F:File;
    Exist :Boolean;
Begin
  System.AsSign(F,FName);
  {$I-}
  ReSet(F);
  {$I+}
  Exist := IoResult = 0;
  If Exist Then Close(F);
  ExistFile := Exist;
End;
function TCopyFile.DefaultDirectory:String;
{** Vraci zakladni direktorar}
var S: String;
Begin
  GetDir (0, S);
  DefaultDirectory := S;
End;

constructor TCopyFile.Create(AOwner: TComponent);
Begin
  inherited Create(AOwner);
End;

destructor TCopyFile.Destroy;
Begin
  inherited Destroy;
End;

Procedure Register;
Begin
  RegisterComponents('JBL',[TCopyFile]);
End;

End.